/*
    Classe CIntercepta
*/

#include <math.h>
#include "CIntercepta.h"

CIntercepta::CIntercepta() {
}

// traz o primeiro ponto do vetor ordenado
CSegmento* CIntercepta::first() {
   CSegmento* s = 0;
   if(points.count() > 1) {
      vet = points.sort();
      seg.p1 = vet[0];
      seg.p2 = vet[1];
      p1 = 0;
      p2 = 2;
      s = &seg;
   }
   return s;
}

// traz o ltimo ponto de interceptao
CSegmento* CIntercepta::last() {
   CSegmento *n = first(), *s = 0;
   while(n) {
      s = n;
      n = next();
   }
   return s;
}

// traz o prximo ponto jarvis
// estratgia: 
CSegmento* CIntercepta::next() {
   CSegmento *s = 0;
   CSegmento s1, s2;
   int i, j, pontos = points.count();
   bool interceptou = true;
   
   while(interceptou) {
                      
      if(p2 >= pontos) break;
      
      s1.p1 = vet[p1];
      s1.p2 = vet[p2];
      interceptou = false;
      
      for(i = 0; i < (p2-1) && !interceptou; i++) {
            for(j = i+1; j < p2 && !interceptou; j++) {
                s2.p1 = vet[i];
                s2.p2 = vet[j];
                interceptou = intercepta(&s1, &s2);
            }
      }
      
      p1 ++;
      if(p1 >= p2) {
            p2++;
            p1 = 0;
      }
   }
   
   if(!interceptou) s = &s1;
   
   return s;
}
     
//funo determina se dois segmentos se interceptam
bool CIntercepta::intercepta(CSegmento *s1, CSegmento *s2) {
     CCoord ca, cb , da, db;
     float cacb, dadb;

     ca.x = s2->p1->x - s1->p1->x;
     ca.y = s2->p1->y - s1->p1->y;
     
     cb.x = s2->p1->x - s1->p2->x;
     cb.y = s2->p1->y - s1->p2->y;

     da.x = s2->p2->x - s1->p1->x;
     da.y = s2->p2->y - s1->p1->y;
     
     db.x = s2->p2->x - s1->p2->x;
     db.y = s2->p2->y - s1->p2->y;
     
     cacb = ca.x*cb.y - ca.y*cb.x;
     dadb = da.x*db.y - da.y*db.x;
     
     return !(cacb <= 0 && dadb <= 0 || cacb >= 0 && dadb >= 0 );
}

