/*
    Header da classe CPoints
*/

#ifndef _CPOINTS_
#define _CPOINTS_

    struct CCoord {
           float x;
           float y;
           float z; 
           bool jarvis;
    };
    
    struct CVertex {
           CCoord *data;
           CVertex *next;
    };

    class CPoints {
          private:
                  CVertex *start, *end, *pointer, *pmark;
                  CCoord** vet;
                  int pointcount;
                  void internalSort(CCoord** vet);
                  void initialize();
          public:
                  bool isMarked;
                  
                  CPoints();
                  ~CPoints();
                  
                  void clear();
                  CCoord* add(float x, float y, float z);
                  void remove(int index);
                  int count();
                  CCoord* get(int index);
                  
                  CCoord* first();
                  CCoord* last();
                  CCoord* next();
                  CCoord* get();
                  
                  void mark();
                  void restore();
                  CCoord** sort();
                  
                  void loadFromFile(char * fileName);
                  void loadFromRandom(int size);
    };
    
#endif


